function [wplus,wmoins]=dualtree_Mband2Dcompleted(w,wh,J)

%function [wplus,wmoins]=dualtree_Mband2Dcompleted(w,wh,J)
%
%Last step : combinaison of the output of each filters bank (primal and dual, J decomposition levels )
%We don't process the low pass subbands
%INPUT:
%    w : coefficient issued from the primal tree before rotation
%    wh : coeffcient issued fron the dual tree before rotation
%OUTPUT:
%    wplus : (1/sqrt(2))*(w+wh) excepted for low-pass coefficients
%    wmoins : (1/sqrt(2))*(w-wh) excepted for low-pass coefficients

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, October, 6th                      *
%*****************************************************


for j=1:J,
    for l=2:length(w{j}),
        for m=2:length(w{j}{l}),            
            A=w{j}{l}{m};
            B=wh{j}{l}{m};
            wplus{j}{l}{m}=(1/sqrt(2))*(A+B);
            wmoins{j}{l}{m}=(1/sqrt(2))*(A-B);
        end
    end
    for l=1:length(w{j}),
        wplus{j}{l}{1}=w{j}{l}{1};
        wmoins{j}{l}{1}=wh{j}{l}{1};
    end
    for m=2:length(w{j}{1}),
        wplus{j}{1}{m}=w{j}{1}{m};
        wmoins{j}{1}{m}=wh{j}{1}{m};
    end
    
end