function [Gamma1,Gamma2,Gammah1,Gammah2]=genere_gamma2_freq(Ml,Mc,m,Nl,Nc)

%[Gamma1,Gamma2,Gammah1,Gammah2]=genere_gamma2_freq(Ml,Mc,m,Nl,Nc)
%Genere the filters' coef for prefiltering
%INPUT:
%   rm : used number of decomposition levels to compute filters
%   Ml,Mc : bands numbers column and row
%   m: filters used (see dualtreeM2D_freq.m)
%   Nl,Nc : image's number points, column and row
%OUTPUT:
%   Gamma1, Gamma2 : the gamma function (filter's coef of prefiltering in "normal"
%   tree) in frequential, column and row 
%   Gammah1, Gammah2 : the gammah function (filter's coef of prefiltering
%   in "dual" tree) in frequential, column and row

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle	         *
%* date: Thursday, October, 6th                      *
%*****************************************************


[Phi1,Phi2]=genere_phi_freq(Ml,Mc,m,Ml*Nl,Mc*Nc);

pulsal=2*pi*[0:(Nl-1)]/Nl;
pulsac=2*pi*[0:(Nc-1)]/Nc;

Gamma1=[conj(Phi1(1:Nl/2+1)),Phi1(Nl/2:-1:2)];
Gamma1(Nl/2+1)=real(Phi1(Nl/2+1));
Gammah1=Gamma1.*exp(j*pulsal/2);
%Gammah1(Nl/2+1) = 0;
Gammah1(Nl/2+1) = imag(Phi1(Nl/2+1));
Gammah1(Nl/2+2:Nl)=-Gammah1(Nl/2+2:Nl);

Gamma2=[conj(Phi2(1:Nc/2+1)),Phi2(Nc/2:-1:2)];
Gamma2(Nc/2+1)=real(Phi2(Nc/2+1));
Gammah2=Gamma2.*exp(j*pulsac/2);
%Gammah2(Nc/2+1) = 0;
Gammah2(Nc/2+1) = imag(Phi2(Nc/2+1));
Gammah2(Nc/2+2:Nc)=-Gammah2(Nc/2+2:Nc);


% figure
% subplot 311
% plot(pulsal,abs(Gamma1))
% title('abs Gammal (freq)')
% subplot 312
% plot(pulsal,real(Gamma1))
% title('real Gammal (freq)')
% subplot 313
% plot(pulsal,imag(Gamma1))
% title('imag Gammal (freq)')


% figure
% plot(pulsac,abs(Gamma2))
% title('Gammac (freq)')
%
% figure
% plot(pulsal,abs(Gammah1))
% title('Gammahl (freq)')
% figure
% plot(pulsac,abs(Gammah2))
% title('Gammahc (freq)')
% 

