function [HH1,HH2]=hilbert_filters_freq(H1,H2)

%function [HH1,HH2]=hilbert_filters_freq(H1,H2)
%
%Compute the dual filters.
%INPUT:
%   H1: column filters
%   H2: row filters
%OUTPUT:
%   HH1: dual column filters
%   HH2: dual row filters

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, October, 6th                      *
%*****************************************************


[M1,NF1]=size(H1);
MNF1 = NF1;

[M2,NF2]=size(H2);
MNF2 = NF2;

theta1 = Mphase(MNF1,M1);
etheta1 = exp(-i*theta1);

theta2 = Mphase(MNF2,M2);
etheta2 = exp(-i*theta2);


%Computation of the filters which form an hilbert pair with the filters generated by function filters
HH1 = zeros(size(H1));
HH1(1,:) = H1(1,:).*etheta1(1,:);
for m = 2:M1
    HH1(m,:) = H1(m,:).*etheta1(2,:);
end

%Computation of the filters which form an hilbert pair with the filters generated by function filters
HH2 = zeros(size(H2));
HH2(1,:) = H2(1,:).*etheta2(1,:);
for m = 2:M2
    HH2(m,:) = H2(m,:).*etheta2(2,:);
end
