function [w,wh]=idualtree_Mband2Dcompleted(wplus,wmoins,J)

%function [wplus,wmoins]=dualtree_Mband2Dcompleted(w,wh,J)
%Last step : combinaison of the output of each filters bank (J decomposition levels )
%We don't process the low pass subbands
%INPUT:
%   wplus: primal coef issued from a dual-tree transform
%   wmoins: dual coef issued from a dual-tree transform
%OUTPUT:
%    w : (1/sqrt(2))*(wplus+wmoins) excepted for low-pass coefficients
%    wh : (1/sqrt(2))*(wplus-wmoins) excepted for low-pass coefficients

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle    	     *
%* date: Thursday, October, 6th                      *
%*****************************************************

for j=1:J,
    for l=2:length(wplus{j}),
        for m=2:length(wplus{j}{l}),            
            A=wplus{j}{l}{m};
            B=wmoins{j}{l}{m};
            w{j}{l}{m}=(1/sqrt(2))*(A+B);
            wh{j}{l}{m}=(1/sqrt(2))*(A-B);
        end
    end
    for l=1:length(wplus{j}),
        w{j}{l}{1}=wplus{j}{l}{1};
        wh{j}{l}{1}=wmoins{j}{l}{1};
    end
    for m=2:length(wplus{j}{1}),
        w{j}{1}{m}=wplus{j}{1}{m};
        wh{j}{1}{m}=wmoins{j}{1}{m};
    end
    
end

% %test si toute
% for j=1:J,
%     for l=1:length(wplus{j}),
%         for m=1:length(wplus{j}{l}),            
%             A=wplus{j}{l}{m};
%             B=wmoins{j}{l}{m};
%             w{j}{l}{m}=(1/sqrt(2))*(A+B);
%             wh{j}{l}{m}=(1/sqrt(2))*(A-B);
%         end
%     end
% end