%test_recparf_freq.m
%This function is a test to see if there is perfect reconstrution with the
%dual-tree Mband transform

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, October, 6th                      *
%*****************************************************




%description
disp('This program decomposes an image via a dual-tree M-band transform and reconstructs the obtained coeffients.');

m='haar';
M1=2;M2=2;
rm=2;

load('barbpgm.mat')
x=barb;


x=x(1:M1^rm*floor(size(x,1)/M1^rm),1:M2^rm*floor(size(x,2)/M2^rm));


%decomposition
[wp,wm,H1,H2,HH1,HH2,G,Gh]=dualtreeM2D_freq(x,m,rm);

%plots of the coefficients
plot_dualtree_Mband2D(wp)
plot_dualtree_Mband2D(wm)

%reconstruction
xrec = idualtreeM2D_freq(wp,wm,rm,H1,H2,HH1,HH2,G,Gh);

disp('Original image norm:');
norm(x,'fro').^2
disp('Reconstructed image norm:');
norm(xrec,'fro').^2
disp('Norm of the difference between the original image and the reconstructed one:');
norm(x-xrec,'fro').^2

figure
imagesc(x)
title('Original image')
colormap(gray(256))

figure
imagesc(xrec)
title('Reconstructed image')
colormap(gray(256))

figure
imagesc(x-xrec)
title('Original image minus reconstructed image')
colormap(gray(256))
colorbar
