function h = MLTir(M)
%h = MLTir(M) : fonction generant les reponses impulsionnelles
%des filtres d'une MLT
% M : nombre de sous-bandes
% h : reponse impulsionnelle

%*****************************************************
%* author: Jean-Christophe Pesquet                   *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, October, 6th                      *
%*****************************************************


n = 0:2*M-1;
w = -sin((n+1/2)*pi/(2*M));
k = 0:M-1;
h = sqrt(2/M)*cos((k'+1/2)*(n+(M+1)/2)*pi/M).*(ones(M,1)*w);