function [wps,wms]=estim_geneSP_DTTsub_plus(wp,wm,wvpp,wvpm,wvmm,wvmp,Ncs,gamma,corpDTT,cormDTT)

%ws=estim_geneSP_DTTsub_plus(w,wv,Ncs,gamma)
%input:
%on estime un pixel  partir d'un voisinage prdefini (que l'on choisit
%dans le canal considr et dans les autres canaux) N=1
%wp,wm : stucture contenant les coefs  seuiller
%wv : structure contenant les voisinages (composs de zros et de un)
%     ces voisinages sont de tailles impaires
%gamma : matrice de covariance du bruit : elle est qcq
%corDWT : c'est le gamma ntilde n
%On fait un seuillage gnral
%beta est optimiz
%on prend en compte la dpendance multispectrale
%on prend un bloc (qui peut-tre diffrent) dans chaque canal
%le bloc est diffrent suivant le canal que l'on estime
%on calcul une matrice \bar{q} qui pondre les coefs.
% \bar{q}=\bar{P}a : il est recherch dans un sous-espace.

%N=1;

%nb d'iters pour trouver Pb*a
niterqMAX=3;

%nb de canaux
NC=length(wp);

%besoin  l'avance
% for indn=1:NC,
%     sigma{indn}=sqrt(gamma(indn,indn));
% end

for indn=1:NC,
    %sigmap{indn}=sqrt(gamma(indn,indn));
    sigmap{indn}=sqrt(max(max(corpDTT{indn})));
    %sigmam{indn}=sqrt(gamma(indn,indn));
    sigmam{indn}=sqrt(max(max(cormDTT{indn})));
end


disp('Etape 1 : on remplit les blocs');
for indn=1:NC,
    disp('Etape 1b : pour tous les canaux');
    %taille impair
    for n=1:length(wvpp)
        if rem(size(wvmm{indn}{n},1),2)==0 || rem(size(wvmp{indn}{n},2),2)==0 || rem(size(wvpm{indn}{n},2),2)==0 || rem(size(wvpp{indn}{n},2),2)==0;
            error('La taille du voisinage doit tre impaire');
        end
    end


    %extension for overlapping
    for n=1:length(wp)
        wpa{n}=[wp{n}(:,floor(size(wvpp{indn}{n},2)/2):-1:1),wp{n},wp{n}(:,end:-1:end-floor(size(wvpp{indn}{n},2)/2)+1)];
        wpa{n}=[wpa{n}(floor(size(wvpp{indn}{n},1)/2):-1:1,:);wpa{n};wpa{n}(end:-1:end-floor(size(wvpp{indn}{n},1)/2)+1,:)];
        wma{n}=[wm{n}(:,floor(size(wvmm{indn}{n},2)/2):-1:1),wm{n},wm{n}(:,end:-1:end-floor(size(wvmm{indn}{n},2)/2)+1)];
        wma{n}=[wma{n}(floor(size(wvmm{indn}{n},1)/2):-1:1,:);wma{n};wma{n}(end:-1:end-floor(size(wvmm{indn}{n},1)/2)+1,:)];

    end


    k=1;
    % blocs construction --> autant de blocs que de pixels
    %R{indn}{k}=[];
    for i=1:size(wp{indn},1),
        for j=1:size(wp{indn},2),

            Rp{indn}{k}=[wp{indn}(i,j)];
            Rm{indn}{k}=[wm{indn}(i,j)];

            %overlapping
            Rpab{indn}{k}=[];
            Rmab{indn}{k}=[];
            for n=1:length(wp),
                Rpab{indn}{k}=[Rpab{indn}{k};(wpa{n}(i:i+size(wvpp{indn}{n},1)-1,j:j+size(wvpp{indn}{n},2)-1)).*wvpp{indn}{n};(wma{n}(i:i+size(wvpm{indn}{n},1)-1,j:j+size(wvpm{indn}{n},2)-1)).*wvpm{indn}{n}];
                Rmab{indn}{k}=[Rmab{indn}{k};(wma{n}(i:i+size(wvmm{indn}{n},1)-1,j:j+size(wvpp{indn}{n},2)-1)).*wvmm{indn}{n};(wpa{n}(i:i+size(wvmp{indn}{n},1)-1,j:j+size(wvmp{indn}{n},2)-1)).*wvmp{indn}{n}];
            end
            %Rab{indn}{k}=Rab{indn}{k}(:);
            Rpa{indn}{k}=Rpab{indn}{k}(find(Rpab{indn}{k}));
            Rma{indn}{k}=Rmab{indn}{k}(find(Rmab{indn}{k}));

            k=k+1;
        end
    end

    %     %overlapping
    %     k=1;
    %     for i=1:size(w{indn},1),
    %         for j=1:size(w{indn},2),
    %             Rab{indn}{k}=[];
    %             for n=1:length(w),
    %                 Rab{indn}{k}=[Rab{indn}{k},(wa{n}(i:i+size(wv{indn}{n},1)-1,j:j+size(wv{indn}{n},2)-1)).*wv{indn}{n}];
    %             end
    %             Rab{indn}{k}=Rab{indn}{k}(:);
    %             Ra{indn}{k}=Rab{indn}{k}(find(Rab{indn}{k}));
    %             k=k+1;
    %         end
    %     end
end

%Initialisation de \bar{q}
%attention il a la mme taille que le voisinage
%le voisinage a t mi en vecteur colonne
%lui aussi

disp('Etape 2 : on attaque les risques. Def de Qp=Ppa et Qm=Pma et gamman');
for indn=1:NC,
    %disp('On le fait pour chaque composante');
    %ATTENTION: Le fait que j'inverse les roles pour l'arbre m et p fait que
    %Pb et Pm sont les mmes au dpart.
    %on recharge le premier \bar{q}
    %il vaut 1 au pixel extim, 0 ailleurs
    voism=[];
    voisp=[];
    for n=1:NC,
        voism=[voism;wvmm{indn}{n};wvmp{indn}{n}];
        voisp=[voisp;wvpp{indn}{n};wvpm{indn}{n}];
    end

    %nb de points de \bar{r} pour arbres primal et dual
    dp=length(find(voisp));
    dm=length(find(voism));

    %Dfinition de la nouvelle matrice P et a
    %je choisis de prendre dpr=NC+4 pour faire une combinaison linaire des canaux
    %et de 4 coefs spat (+) que ce soit pour l'arbre primal ou le dual
    dpr=NC+4;
    Pbp=zeros(dp,dpr);
    Pbm=zeros(dm,dpr);
    ap=zeros(dpr,1);
    am=zeros(dpr,1);
    %La matrice Pp et Pm va donc valoir 1 pour tous les canaux p ou m  la position du
    %point estim
    Ptempp=zeros(size(voisp));
    Ptempm=zeros(size(voism));
    for n=1:NC,
        Ptempp((2*n-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2)+1,floor(size(wvpp{indn}{indn},1)/2)+1)=1;
        Ptempm((2*n-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2)+1,floor(size(wvmm{indn}{indn},1)/2)+1)=1;
    end
    %et on prend du spatial
    Ptempp((2*indn-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2)+1,floor(size(wvpp{indn}{indn},1)/2))=1;
    Ptempm((2*indn-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2)+1,floor(size(wvmm{indn}{indn},1)/2))=1;
    Ptempp((2*indn-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2)+1,floor(size(wvpp{indn}{indn},1)/2)+2)=1;
    Ptempm((2*indn-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2)+1,floor(size(wvmm{indn}{indn},1)/2)+2)=1;
    Ptempp((2*indn-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2)+2,floor(size(wvpp{indn}{indn},1)/2)+1)=1;
    Ptempm((2*indn-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2)+2,floor(size(wvmm{indn}{indn},1)/2)+1)=1;
    Ptempp((2*indn-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2),floor(size(wvpp{indn}{indn},1)/2)+1)=1;
    Ptempm((2*indn-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2),floor(size(wvmm{indn}{indn},1)/2)+1)=1;
    Ptemp2p=Ptempp(find(voisp));
    Ptemp2m=Ptempm(find(voism));
    indPp=find(Ptemp2p);
    indPm=find(Ptemp2m);
    n=1;
    for i=indPp',
        Pbp(i,n)=1;
        n=n+1;
    end
    n=1;
    for i=indPm',
        Pbm(i,n)=1;
        n=n+1;
    end

    %a vaut 1 au point estim
    ap(NC+indn-1)=1;
    am(NC+indn-1)=1;

    %juste pour avoir la position du poin  estimer
    testp=zeros(size(voisp));
    ind1p=(2*indn-2)*size(wvpp{indn}{indn},1)+floor(size(wvpp{indn}{indn},1)/2)+1;
    ind2p=floor(size(wvpp{indn}{indn},1)/2)+1;
    testp(ind1p,ind2p)=1;
    %c'est un vecteur colonne
    testp=testp(find(voisp));
    %dfinition du point o le pixel vaut 1
    indqb1p=find(testp);

    testm=zeros(size(voism));
    ind1m=(2*indn-2)*size(wvmm{indn}{indn},1)+floor(size(wvmm{indn}{indn},1)/2)+1;
    ind2m=floor(size(wvmm{indn}{indn},1)/2)+1;
    testm(ind1m,ind2m)=1;
    %c'est un vecteur colonne
    testm=testm(find(voism));
    %dfinition du point o le pixel vaut 1
    indqb1m=find(testm);
    %on a qb=Pb a mais on ne va se servir que de P et a
    %     disp('Pbp, ap et Pbp*ap');
    %     Pbp,ap,Pbp*ap
    %     disp('Pbm, am et Pbm*am');
    %     Pbm,am,Pbm*am

    %def de P et Pt
    Pp=Pbp(indqb1p,:)';
    Ptp=[Pbp(1:indqb1p-1,:);Pbp(indqb1p+1:end,:)];
    Pm=Pbm(indqb1m,:)';
    Ptm=[Pbm(1:indqb1m-1,:);Pbm(indqb1m+1:end,:)];

    %calcul du gammantilden ou gammant correspondant
    %il sera lui aussi en colonne
    gammanttp=corpDTT{indn};
    gammanttp=gammanttp(find(voisp));
    %attention : le point estim ne fait pas partir de gammant !
    gammantp=[gammanttp(1:indqb1p-1);gammanttp(indqb1p+1:end)];
    %disp('Affichage du gammanttp et gammantp:');
    %gammanttp,gammantp
    gammanttm=cormDTT{indn};
    gammanttm=gammanttm(find(voism));
    %attention : le point estim ne fait pas partir de gammant !
    gammantm=[gammanttm(1:indqb1m-1);gammanttm(indqb1m+1:end)];
    %     disp('Affichage du gammanttm et gammantm:');
    %     gammanttm,gammantm

    if size(gammantp,1)~=size(Ptp,1) || size(gammantm,1)~=size(Ptm,1)
        error('qt et Pt doivent avoir la mme taille !!!');
    end

    disp('Etape 3 : calcul de lambda et beta');

    for niterq=1:niterqMAX,
        l=1;
        K=length(Rp{indn});

        % la 1re boucle ainter a aura chang
        ainterp=ap;
        ainterm=am;

        if size(ap,2)~=1 || size(am,2)~=1
            error('2) ap et am vecteurs colonnes');
        end

        valbeta=[0.5 1 1.5 2];
        for beta = valbeta,
            %beta fix
            %for beta = 2,
            %construction of the vector containing blocks norms

            %Rb est un scalaire donc pas de norm et de plus, je n'en ai pas
            %besoin  la puissance beta !
            %disp('Mise en place des vecteurs  trier');
            Rpk=zeros(1,K+1);
            Rmk=zeros(1,K+1);
            for k=1:K,
                Rpk(k)=(Rp{indn}{k});
                Rmk(k)=(Rm{indn}{k});
            end
            Rpk(K+1)=0;
            Rmk(K+1)=0;

            normRpka=zeros(1,K+1);
            normRmka=zeros(1,K+1);
            for k=1:K,
                normRpka(k)=norm(Rpa{indn}{k},'fro')^beta;
                normRmka(k)=norm(Rma{indn}{k},'fro')^beta;
            end
            normRpka(K+1)=0;
            normRmka(K+1)=0;

            %sort les ||rb||^beta
            [snormRpka,indip]=sort(normRpka,'descend');
            [snormRmka,indim]=sort(normRmka,'descend');

            %sort des r
            sRpk=Rpk(indip);
            sRmk=Rmk(indim);

            %sort des rb qui sont les voisinages tri.
            k=1;
            for i=indip,
                if i==indip(end)
                    rpb{indn}{k}=zeros(size(Rpa{indn}{i-1}));
                else rpb{indn}{k}=Rpa{indn}{i};
                end
                k=k+1;
            end

            k=1;
            for i=indim,
                if i==indim(end)
                    rmb{indn}{k}=zeros(size(Rma{indn}{i-1}));
                else rmb{indn}{k}=Rma{indn}{i};
                end
                k=k+1;
            end

            %sort des rtilde ou rt avec rien en indqb1;
            k=1;
            for i=indip,
                if i==indip(end)
                    rpt{indn}{k}=zeros(size(Rpa{indn}{i-1},1)-1,size(Rpa{indn}{i-1},2));
                else rpt{indn}{k}=[Rpa{indn}{i}(1:indqb1p-1);Rpa{indn}{i}(indqb1p+1:end)];
                end
                k=k+1;
            end

            k=1;
            for i=indim,
                if i==indim(end)
                    rmt{indn}{k}=zeros(size(Rma{indn}{i-1},1)-1,size(Rma{indn}{i-1},2));
                else rmt{indn}{k}=[Rma{indn}{i}(1:indqb1m-1);Rma{indn}{i}(indqb1m+1:end)];
                end
                k=k+1;
            end

            %construction de aTPbTrb
            for k=1:K+1
                aTPbTrpb(k)=ap'*(Pbp'*rpb{indn}{k});
            end

            for k=1:K+1
                aTPbTrmb(k)=am'*(Pbm'*rmb{indn}{k});
            end

            %construction de aTPtTgammant
            aTPtTgammantp=ap'*(Ptp'*gammantp);
            aTPtTgammantm=am'*(Ptm'*gammantm);

            %construction de rtTgammant
            for k=1:K+1
                %size(rt{indn}{k})
                %size(gammant)
                rtTgammantp(k)=rpt{indn}{k}'*gammantp;
                rtTgammantm(k)=rmt{indn}{k}'*gammantm;
            end

            %disp('Calcul de lambda k0');
            lambdak0p=cumsum((aTPbTrpb(1:K).*(aTPbTrpb(1:K)-sRpk(1:K))+sigmap{indn}^2*(Pp'*ap)+aTPtTgammantp)./snormRpka(1:K)-(beta*aTPbTrpb(1:K).*(sigmap{indn}^2*sRpk(1:K)+rtTgammantp(1:K))./snormRpka(1:K).^((beta+2)/beta)))./(cumsum(aTPbTrpb(1:K).^2./snormRpka(1:K).^(2*beta/beta)));
            lambdak0m=cumsum((aTPbTrmb(1:K).*(aTPbTrmb(1:K)-sRmk(1:K))+sigmam{indn}^2*(Pm'*am)+aTPtTgammantm)./snormRmka(1:K)-(beta*aTPbTrmb(1:K).*(sigmam{indn}^2*sRmk(1:K)+rtTgammantm(1:K))./snormRmka(1:K).^((beta+2)/beta)))./(cumsum(aTPbTrmb(1:K).^2./snormRmka(1:K).^(2*beta/beta)));
            %replacing
            %test
            %if(lambdak0<snormRka(1:K))
            %    flag=1
            %else flag=0
            %end
            %             indp=lambdak0p>snormRpka(2:K+1);
            %             indm=lambdak0m>snormRmka(2:K+1);
            %             % save('ind.mat','ind');
            %             % sind=sum(ind);
            %             nlambdap=(1-indp).*snormRpka(2:K+1)+indp.*lambdak0p;
            %             nlambdam=(1-indm).*snormRmka(2:K+1)+indm.*lambdak0m;

            ind1p=lambdak0p>snormRpka(2:K+1);
            ind2p=lambdak0p<snormRpka(1:K);
            indp=(lambdak0p>snormRpka(2:K+1))&(lambdak0p<snormRpka(1:K));
            % save('ind.mat','ind');
            % sind=sum(ind);
            nlambdap=(1-ind1p).*snormRpka(2:K+1)+indp.*lambdak0p+(1-ind2p).*snormRpka(1:K);

            ind1m=lambdak0m>snormRmka(2:K+1);
            ind2m=lambdak0m<snormRmka(1:K);
            indm=(lambdak0m>snormRmka(2:K+1))&(lambdak0m<snormRmka(1:K));
            % save('ind.mat','ind');
            % sind=sum(ind);
            nlambdam=(1-ind1m).*snormRmka(2:K+1)+indm.*lambdak0m+(1-ind2m).*snormRmka(1:K);


            %disp('calcul du risque');
            %risk calculation
            risksp=(nlambdap.^2).*cumsum((aTPbTrpb(1:K)).^2./snormRpka(1:K).^2)+2*nlambdap.*cumsum((aTPbTrpb(1:K).*(sRpk(1:K)-aTPbTrpb(1:K))-aTPtTgammantp-sigmap{indn}^2*(Pp'*ap))./snormRpka(1:K)+(beta*aTPbTrpb(1:K).*(sigmap{indn}^2*sRpk(1:K)+rtTgammantp(1:K)))./snormRpka(1:K).^((beta+2)/beta))+fliplr(cumsum(fliplr(sRpk(2:K+1).^2)))+cumsum(aTPbTrpb(1:K).*(aTPbTrpb(1:K)-2*sRpk(1:K)))-K*sigmap{indn}^2*ones(1,K)+2*((2:K+1)-1)*(sigmap{indn}^2*(Pp'*ap)+aTPtTgammantp);
            [riskp(l),bestp(l)]=min(risksp);
            lambdaep(l) = nlambdap(bestp(l));
            %risk calculation
            risksm=(nlambdam.^2).*cumsum((aTPbTrmb(1:K)).^2./snormRmka(1:K).^2)+2*nlambdam.*cumsum((aTPbTrmb(1:K).*(sRmk(1:K)-aTPbTrmb(1:K))-aTPtTgammantm-sigmam{indn}^2*(Pm'*am))./snormRmka(1:K)+(beta*aTPbTrmb(1:K).*(sigmam{indn}^2*sRmk(1:K)+rtTgammantm(1:K)))./snormRmka(1:K).^((beta+2)/beta))+fliplr(cumsum(fliplr(sRmk(2:K+1).^2)))+cumsum(aTPbTrmb(1:K).*(aTPbTrmb(1:K)-2*sRmk(1:K)))-K*sigmam{indn}^2*ones(1,K)+2*((2:K+1)-1)*(sigmam{indn}^2*(Pm'*am)+aTPtTgammantm);
            [riskm(l),bestm(l)]=min(risksm);
            lambdaem(l) = nlambdam(bestm(l));

            l=l+1;
        end
        disp('Recherche du lambda et beta optimaux');
        %choice of better lambda and beta
        [rp,indrp]=min(riskp);
        lambdap=lambdaep(indrp);
        betaoptp=valbeta(indrp);
        [rm,indrm]=min(riskm);
        lambdam=lambdaem(indrm);
        betaoptm=valbeta(indrm);

        %beta fix
        %lambda=lambdae(1);
        %betaopt=2;

        %updating
        normRpka=zeros(1,K+1);
        normRmka=zeros(1,K+1);
        for k=1:K,
            normRpka(k)=norm(Rpa{indn}{k},'fro')^betaoptp;
            normRmka(k)=norm(Rma{indn}{k},'fro')^betaoptm;
        end
        normRpka(K+1)=0;
        normRmka(K+1)=0;

        %security
        n=prod(size(wp{indn}));
        %sigma=sqrt(gamma(indn,indn));
        etap=(norm(wp{indn},'fro')^2-n*sigmap{indn}^2)/n;
        etam=(norm(wm{indn},'fro')^2-n*sigmam{indn}^2)/n;
        %eta=(sum(w{indn}(:).^2)-n*sigma{indn}^2)/n;
        critp=sigmap{indn}*log(n)^(1.5)/sqrt(n);
        critm=sigmam{indn}*log(n)^(1.5)/sqrt(n);
        if etap < critp ,
            %disp('securityp');
            b1l=1;
            b1c=1;
            wps{indn}=cai_silverman_est(wp{indn},sigmap{indn},Ncs,'securitym',b1l,b1c);
            %T=sqrt(2*log(n));
            %ws{indn} = wthresh(w{indn},'h',T);
        else

            disp('Etape 4: seuillage');
            %block threshold
            %taille de rb
            %disp('Initialisation et taille de ap');
            exp1p=zeros(dpr);
            exp2p=zeros(dpr,1);
            exp3p=zeros(dpr,1);
            exp4p=zeros(dpr,1);
            exp5p=zeros(dpr,1);
            exp6p=zeros(dpr,1);

            for k=1:K,
                %                 if rem(k,5000)==0
                %                     disp('Nb itrations restant:'), K-k
                %                 end
                if (normRpka(k)==0),
                    normRpka(k)=lambdap;
                end

                %construction de rtTgammant2 non tri
                %disp('Construction de rtTgamman');
                %for i=1:K,
                rtTgammant2p=[Rpa{indn}{k}(1:indqb1p-1);Rpa{indn}{k}(indqb1p+1:end)]'*gammantp;
                %end

                gammaup=max(0,1-(lambdap/normRpka(k)));

                %disp('Calcul des 6 expressions');
                exp1p=exp1p+gammaup^2*(Pbp'*Rpa{indn}{k})*(Rpa{indn}{k}'*Pbp);
                exp2p=exp2p+gammaup*Pbp'*Rpa{indn}{k}*Rp{indn}{k};
                exp3p=exp3p+sigmap{indn}^2*Pp*gammaup;
                exp4p=exp4p+(Ptp'*gammantp)*gammaup;
                if normRpka(k)>lambdap
                    exp5p=exp5p+sigmap{indn}^2*lambdap*betaoptp/(normRpka(k)^((betaoptp+2)/betaoptp))*(Pbp'*Rpa{indn}{k})*Rp{indn}{k};
                    exp6p=exp6p+lambdap*betaoptp./(normRpka(k)^((betaoptp+2)/betaoptp))*(Pbp'*Rpa{indn}{k})*rtTgammant2p;
                end
            end

            %c'est une esprance
            exp1p=exp1p/K;
            exp2p=exp2p/K;
            exp3p=exp3p/K;
            exp4p=exp4p/K;
            exp5p=exp5p/K;
            exp6p=exp6p/K;

            %             size(exp1)
            %             size(exp2)
            %             size(exp3)
            %             size(exp4)
            %             size(exp5)
            %             size(exp6)


            %disp('Calcul du ap intermdiaire');
            ap=pinv(exp1p)*(exp2p-exp3p-exp4p-exp5p-exp6p);
            anp=ap;

            if niterq==niterqMAX
                disp('Dernire tape, on seuil la sous-bande');
                Pbap=Pbp*ap;
                k=1;
                for i=1:size(wp{indn},1),
                    for j=1:size(wp{indn},2),
                        wps{indn}(i,j)=max(0,1-(lambdap/normRpka(k)))*((ap'*Pbp')*Rpa{indn}{k});
                        k=k+1;
                    end
                end
            end
        end

        if etam < critm ,
            %disp('securitym');
            b1l=1;
            b1c=1;
            wms{indn}=cai_silverman_est(wm{indn},sigmam{indn},Ncs,'securitym',b1l,b1c);
            %T=sqrt(2*log(n));
            %ws{indn} = wthresh(w{indn},'h',T);
        else

            disp('Etape 4: seuillage');
            %block threshold
            %taille de rb
            %disp('Initialisation et taille de am');
            exp1m=zeros(dpr);
            exp2m=zeros(dpr,1);
            exp3m=zeros(dpr,1);
            exp4m=zeros(dpr,1);
            exp5m=zeros(dpr,1);
            exp6m=zeros(dpr,1);

            for k=1:K,
                %                 if rem(k,5000)==0
                %                     disp('Nb itrations restant:'), K-k
                %                 end
                if (normRmka(k)==0),
                    normRmka(k)=lambdam;
                end

                %construction de rtTgammant2 non tri
                %disp('Construction de rtTgamman');
                %for i=1:K,
                rtTgammant2m=[Rma{indn}{k}(1:indqb1m-1);Rma{indn}{k}(indqb1m+1:end)]'*gammantm;
                %end

                gammaum=max(0,1-(lambdam/normRmka(k)));

                %disp('Calcul des 6 expressions');
                exp1m=exp1m+gammaum^2*(Pbm'*Rma{indn}{k})*(Rma{indn}{k}'*Pbm);
                exp2m=exp2m+gammaum*Pbm'*Rma{indn}{k}*Rm{indn}{k};
                exp3m=exp3m+sigmam{indn}^2*Pm*gammaum;
                exp4m=exp4m+(Ptm'*gammantm)*gammaum;
                if normRmka(k)>lambdam
                    exp5m=exp5m+sigmam{indn}^2*lambdam*betaoptm/(normRmka(k)^((betaoptm+2)/betaoptm))*(Pbm'*Rma{indn}{k})*Rm{indn}{k};
                    exp6m=exp6m+lambdam*betaoptm./(normRmka(k)^((betaoptm+2)/betaoptm))*(Pbm'*Rma{indn}{k})*rtTgammant2m;
                end
            end

            %c'est une esprance
            exp1m=exp1m/K;
            exp2m=exp2m/K;
            exp3m=exp3m/K;
            exp4m=exp4m/K;
            exp5m=exp5m/K;
            exp6m=exp6m/K;

            %             size(exp1)
            %             size(exp2)
            %             size(exp3)
            %             size(exp4)
            %             size(exp5)
            %             size(exp6)


            %disp('Calcul du am intermdiaire');
            am=pinv(exp1m)*(exp2m-exp3m-exp4m-exp5m-exp6m);
            anm=am;

            if niterq==niterqMAX
                disp('Dernire tape, on seuil la sous-bande');
                Pbam=Pbm*am;
                k=1;
                for i=1:size(wm{indn},1),
                    for j=1:size(wm{indn},2),
                        wms{indn}(i,j)=max(0,1-(lambdam/normRmka(k)))*((am'*Pbm')*Rma{indn}{k});
                        k=k+1;
                    end
                end
            end
        end
    end
end