function sbs=cai_silverman_est(sb,sigma,N,cas,L1l,L1c,ml,mc)

%sb est une sous-bande : sont exclues les approx et redecompositions

if nargin<7 ml=1;mc=1; end

N=N^2;
%def du lambda
%si neighcoef (on estime 1 pt  partir de 3 pts)
%lambda=2/3*log(N);

%si L=log(n)
%lambda=4.50524;
%si L=log(n)^(1+d)
%lambda=1;

%[nl,nc]=size(sb);


switch cas
    case 'var'
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Si taille varie en fonction de la sous-bande
        lambda=1;
        %N=N^2;
        L0l=floor(log(N)/2);
        L0c=floor(log(N)/2);
        if ml==mc,
            L1l=max(1,floor(L0l/2));
            L1c=max(1,floor(L0c/2));
        elseif ml>mc,
            L1l=max(1,floor(L0l/2)-1);
            L1c=max(1,floor(L0c/2)+1);
        elseif ml<mc,
            L1l=max(1,floor(L0l/2)+1);
            L1c=max(1,floor(L0c/2)-1);
        end
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;

        %         %def de la taille des blocs
        %         L0l=floor(log(nl)/2);
        %         L0c=floor(log(nc)/2);
        %         L1l=max(1,floor(L0l/2));
        %         L1c=max(1,floor(L0c/2));
        %         Ll=L0l+2*L1l;
        %         Lc=L0c+2*L1c;



    case 'cst'
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Si taille constante
        %         L0l=floor(log(N)/2);
        %         L0c=floor(log(N)/2);
        %         L1l=max(1,floor(L0l/2));
        %         L1c=max(1,floor(L0c/2));
        %         L1l=0;
        %         L1c=0;
        %tabsimuls3
        %         L0l=3;
        %         L0c=3;
        %         L1l=1;
        %         L1c=1;
        %         Ll=L0l+2*L1l;
        %         Lc=L0c+2*L1c;
        lambda=1;
        L0=ceil(log(N)/2);
        L0l=round(sqrt(L0));
        L0c=round(sqrt(L0));
        L1l=max(1,round(L0l/2));
        L1c=max(1,round(L0c/2)); 
%         L1l=max(1,floor(L0l/2));
%         L1c=max(1,floor(L0c/2)); 
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;

    case 'cstnl'
        lambda=1;
        L0=ceil(log(N)/2);
        L0l=round(sqrt(L0));
        L0c=round(sqrt(L0));
        L1l=0;
        L1c=0;
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;

    case 'coef'
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        lambda=2/3*log(N);
        %lambda=1;
        L0l=1;
        L0c=1;
        L1l=1;
        L1c=1;
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;

    case 'sis'
        lambda=1;
        L0=ceil(log(N)/2);
        L0l=round(sqrt(L0));
        L0c=round(sqrt(L0));
        if ml==mc,
            L1l=max(1,floor(L0l/2));
            L1c=max(1,floor(L0c/2));
        elseif ml>mc,
            L0l=L0l-1;
            L0c=L0c+2;
            L1l=max(1,floor(L0l/2)-1);
            L1c=max(1,floor(L0c/2)+1);
        elseif ml<mc,
            L0l=L0l+2;
            L0c=L0c-1;
            L1l=max(1,floor(L0l/2)+1);
            L1c=max(1,floor(L0c/2)-1);
        end
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;

    case 'security'
        lambda=1;
        L0=ceil(log(N)/2);
        L0l=round(sqrt(L0));
        L0c=round(sqrt(L0));
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;
        
    case 'securitym'
        lambda=2/3*log(N);
        L0l=1;
        L0c=1;
        Ll=L0l+2*L1l;
        Lc=L0c+2*L1c;
end

[sbl,sbc]=size(sb);

%image extension
extl=rem(sbl,L0l);
extc=rem(sbc,L0c);

if L0l==1 && L0c==1,
    sb=sb;
else
    sb=sym_image(sb,L0l-extl,L0c-extc);
end

[nl,nc]=size(sb);

%initialisation
%sbs=sb;


%nb max de blocs
nbl=floor(nl/L0l);
nbc=floor(nc/L0c);


%extension du signal de part et d'autre de L1l et L1c
% sba=zeros(nl+L1l,nc+L1c);
% sba(L1l+1:nl+L1l,L1c+1:nc+L1c)=sb;
% sba=[zeros(nl,L1c),sb,zeros(nl,L1c)];
% sba=[zeros(L1l,size(sba,2));sba;zeros(L1l,size(sba,2))];
sba=[sb(:,L1c:-1:1),sb,sb(:,end:-1:end-L1c+1)];
sba=[sba(L1l:-1:1,:);sba;sba(end:-1:end-L1l+1,:)];


%calcul du S^2 pour le calcul du facteur multiplicatif
S=zeros(nbl,nbc);
for i=1:nbl,
    for j=1:nbc,
        S(i,j)= sum(sum(sba(((i-1)*L0l+1):((i-1)*L0l+Ll),((j-1)*L0c+1):((j-1)*L0c+Lc)).^2));
        if (S(i,j)==0),
            S(i,j)=lambda*sigma^2*(Ll*Lc);
        end

        %facteur multiplicatif
        beta = max(0,1-(lambda*sigma^2*(Ll*Lc))/S(i,j));

        %seuillage
        sbs(((i-1)*L0l+1):(i*L0l),((j-1)*L0c+1):(j*L0c)) = sb(((i-1)*L0l+1):(i*L0l),((j-1)*L0c+1):(j*L0c)) .* beta;
    end
end

sbs=sbs(1:sbl,1:sbc);

