function s=snr2(x,xest)

% function s=snr2(x,xest)
%
% Calculate the SNR between image x and estimated image xest
%INPUT:
%   x: original image
%   xest: estimated image (or noisy image for snr init)
%OUTPUT:
%   s: SNR

%*****************************************************
%* author: Caroline Chaux                            *
%* institution: Institut Gaspard Monge - CNRS	     *
%*	       Universit de Marne la Valle             *
%* date: Thursday, October, 6th                      *
%*****************************************************

s=10*log10(std(x(:))^2*prod(size(x))/norm((x(:)-xest(:)),'fro')^2);

